%{
#include <stdio.h>
#include <stdlib.h>
#include "y.tab.h"

int num_chars = 0;
extern int position;
%}

%%

"let" {num_chars+=yyleng; return (LET);}
"in" {num_chars+=yyleng; return (IN);}
"end" {num_chars+=yyleng; return (END);}
"val" {num_chars+=yyleng; return (VAL);}
"fn" {num_chars+=yyleng; return (FN);}
"=>" {num_chars+=yyleng; return (RA);}
"=" {num_chars+=yyleng; return ('=');}
"(" {num_chars+=yyleng; return ('(');}
")" {num_chars+=yyleng; return (')');}
"\eof" return (EOF);

[a-zA-Z][a-zA-Z0-9]* {
num_chars+=yyleng; 
yylval.id_value = malloc (strlen(yytext) + 1);
strcpy (yylval.id_value, yytext);
//printf ("lineno=%d\n", yylineno);
//printf ("num_chars=%d\n", num_chars);
//printf ("position=%d\n", position);
return (ID);
}

[0-9][0-9]* {
num_chars+=yyleng; 
sscanf(yytext,"%d",&yylval.int_value);
return (NUM);
}

[\n\t ]+  {
num_chars+=yyleng;
if (num_chars == position-1) {
 return (CURSOR);
}
}

%%
